/**
 * Assignment #6: Page Replacement Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#include "MFU.h"

using namespace std;

int    MFU::total_hit_count  = 0;
double MFU::total_swap_count = 0;

void MFU::init()
{
    frequencies = vector<int>(ref_string.size(), 0);
}

void MFU::load_page(const int ref)
{
    frequencies[ref]++;
}

int MFU::choose_victim_frame(const int ref_index)
{
    int most_freq = -1;
    int most_frame;

    for (int i = 0; i < frame_count; i++)
    {
        int ref = frames[i];
        if (frequencies[ref] > most_freq)
        {
            most_freq = frequencies[ref];
            most_frame = i;
        }
    }

    return most_frame;
}

void MFU::record_hit()
{
    ++total_hit_count;
}

void MFU::record_swap(double amount)
{
    total_swap_count += amount;
}
